# Laravel onfido
[![Packagist](https://img.shields.io/packagist/l/doctrine/orm.svg)](https://packagist.org/packages/mahshamim/hits-onfido)

This is a PHP API client for Onfido's REST API.

We have kept this library as close to [the original](https://gitlab.com/mah.shamim/hits-laraval-onfido.git) as possible and so can be used as the [documentation](https://onfido.com/documentation#documents) states.

In order to run the tests, you must update the AbstractTest file with your api token.  The tests are poor as they depend upon data on your Onfido account (e.g. customer ids).

These are the original unit tests that Onfido provided.

This branch (master) has modifications from the original SDK.  This version returns arrays instead on instances of StdClass or a string.

# Installation

You can obtain onfido-php from source

    $ git clone https://gitlab.com/mah.shamim/hits-laraval-onfido.git
    
or you can install via composer:

    $ composer require mahshamim/hits-onfido

# Usage

At the beginning, You need is to import the autoload.php file, Initiate the Config, and Set the Token:

    require_once('autoload.php');

    \Onfido\Config::init()->set_token('YOUR TOKEN');

## Applicants

The [applicant](https://onfido.com/documentation#applicants) endpoint supports two operations - ``create()`` and ``get()``:

### Create applicant

    $applicant = new \Mahshamim\Onfido\Applicant();
    $applicant->first_name = 'John';
    $applicant->last_name = 'Smith';
    $applicant->email = 'email@server.com';

    $address1 = new \Mahshamim\Onfido\Address();
    $address1->postcode = 'abc';
    $address1->town = 'London';
    $address1->country = 'GBR';

    $applicant->addresses = Array($address1);

    $response = $applicant->create();

### Retrieve applicant
``APPLICANT_ID`` to be the ID of the Applicants You want to retrieve.

    $applicant = (new \Mahshamim\Onfido\Applicant())->get(APPLICANT_ID);

### List applicants
``->paginate(2, 5)`` means to get page #2 where each page has 5 Applicants, Any of both can be null to ignore

    \Mahshamim\Onfido\Config::init()->set_token('YOUR TOKEN')->paginate(2, 5);

    $applicants = (new \Mahshamim\Onfido\Applicant())->get();

## Documents

The [documents](https://onfido.com/documentation#documents) endpoint supports one operation - upload_for():


### Upload document
    $document = new \Mahshamim\Onfido\Document();

    $document->file_name = 'file.jpg';
    $document->file_path = '/path/to/file.jpg';
    $document->file_type = 'image/jpg';
    $document->type = 'passport';
    $document->side = 'front';

    $response = $document->upload_for(APPLICANT_ID);


## Checks

The [checks](https://onfido.com/documentation#checks) endpoint supports two operations - ``create_for()`` and ``get()``:

### Create check

    $check = new \Mahshamim\Onfido\Check();
    $check->type = 'standard';

    $report1 = new \Mahshamim\Onfido\CheckReport();
    $report1->name = 'identity';

    $check->reports = Array(
        $report1
    );
    $response = $check->create_for(APPLICANT_ID);


### Retrieve check

    $check = (new \Mahshamim\Onfido\Check())->getCheckRetrieve(CHECK_ID);

### List checks

    \Mahshamim\Onfido\Config::init()->set_token('YOUR TOKEN')->paginate(null, 5);

    $checks = (new \Mahshamim\Onfido\Check())->getCheckList(APPLICANT_ID);


## Reports

The [reports](https://onfido.com/documentation#reports) endpoint supports one operation - ``get()``:

### Retrieve report

	$report = (new \Mahshamim\Onfido\Report())->getReportRetrieve(REPORT_ID);

### List reports

    $report = (new \Mahshamim\Onfido\Report())->getReportList(CHECK_ID);

## Address Picker
You can get use of the Onfido [Address Picker](https://onfido.com/documentation#address-picker), like:

    $address = new \Mahshamim\Onfido\AddressPicker();
    $address->postcode = 'SW4 6EH';
    $addresses = $address->pick();

# Running tests
You will need to have latest version of [phpunit](https://phpunit.de/manual/current/en/installation.html) installed. Then:

    phpunit Applicants.php

will run the tests related to Applicant endpoint operations, and shows the results in a readable way.
You can run other tests like: Checks, Documents and Reports.
